//+------------------------------------------------------------------------------------+
//|                   ATR_&_Price_Distance_To_MA_Mtf_Dashboard_ScFix_Tf_Buttons_V1.mq4 |
//|                                                Created By ExplosionKibo 2021.06.25 |
//+------------------------------------------------------------------------------------+
#property copyright "2021.06.25 Created By ExplosionKibo @ FF"
#property indicator_chart_window
#include <stdlib.mqh>
#include <stderror.mqh>

enum fonts
{
font1,/*Aharoni*/ font2,/*Algerian*/ font3,/*Andalus*/ font4,/*Angsana New*/ font5,/*AngsanaUPC*/ font6,/*Aparajita*/ font7,/*Arabic Typesetting*/ font8,/*Arial*/ font9,/*Arial Black*/ 
font10,/*Arial Narrow*/ font11,/*Arial Unicode MS*/ font12,/*Baskenville Old Face*/ font13,/*Batang*/ font14,/*BatangChe*/ font15,/*Bauhaus 93*/ font16,/*Bell MT*/ font17,/*Berlin Sans FB*/ font18,/*Berlin Sans FB Demi*/ font19,/*Bernard MT Condensed*/ 
font20,/*Bodoni MT Poster Compressed*/ font21,/*Book Antiqua*/ font22,/*Bookman Old Style*/ font23,/*Bookshelf Symbol 7*/ font24,/*Britannic Bold*/ font25,/*Broadway*/ font26,/*Browallia New*/ font27,/*Browa|liaUPC*/ font28,/*Brush Script MT*/ font29,/*Calibri*/ 
font30,/*Calibri Light*/ font31,/*Californian FB*/ font32,/*Cambria*/ font33,/*Cambria Math*/ font34,/*Candara*/ font35,/*Centaur*/ font36,/*Century*/ font37,/*Century Gothic*/ font38,/*Chiller*/ font39,/*Colonna MT*/ 
font40,/*Comic Sans MS*/ font41,/*Consolas*/ font42,/*Constantia*/ font43,/*Cooper Black*/ font44,/*Corbel*/ font45,/*Cordia New*/ font46,/*CordiaUPC*/ font47,/*Courier*/ font48,/*Courier New*/ font49,/*DaunPenh*/ 
font50,/*David*/ font51,/*DFKai-SB*/ font52,/*DilleniaUPC*/ font53,/*DokChampa*/ font54,/*Dotum*/ font55,/*DotumChe*/ font56,/*Ebrima*/ font57,/*Estrangelo Edessa*/ font58,/*EucrosiaUPC*/ font59,/*Euphemia*/ 
font60,/*FangSong*/ font61,/*Fixedsys*/ font62,/*Footlight MT Light*/ font63,/*Franklin Gothic Medium*/ font64,/*FrankRuehl*/ font65,/*FreesiaUPC*/ font66,/*Freestyle Script*/ font67,/*Gabriola*/ font68,/*Garamond*/ font69,/*Gautami*/ 
font70,/*Georgia*/ font71,/*Gisha*/ font72,/*Gulim*/ font73,/*GulimChe*/ font74,/*Gungsuh*/ font75,/*GungsuhChe*/ font76,/*Haettenschweiler*/ font77,/*Harlow Solid Italic*/ font78,/*Harrington*/ font79,/*High Tower Text*/ 
font80,/*Impact*/ font81,/*Informal Roman*/ font82,/*IrisUPC*/ font83,/*Iskoola Pota*/ font84,/*JasmineUPC*/ font85,/*Jokerman*/ font86,/*Juice ITC*/ font87,/*KaiTi*/ font88,/*Kalinga*/ font89,/*Kartika*/ 
font90,/*Khmer UI*/ font91,/*KodchiangUPC*/ font92,/*Kokila*/ font93,/*Kristen ITC*/ font94,/*Kunstler Script*/ font95,/*Lao UI*/ font96,/*Latha*/ font97,/*Lato*/ font98,/*Lato Light*/ font99,/*Lato Semibold*/ 
font100,/*Leelawadee*/ font101,/*Levenim MT*/ font102,/*LilyUPC*/ font103,/*Lucida Bright*/ font104,/*Lucida Calligraphy*/ font105,/*Lucida Console*/ font106,/*Lucida Fax*/ font107,/*Lucida Handwriting*/ font108,/*Lucida Sans Unicode*/ font109,/*Magneto*/ 
font110,/*Malgun Gothic*/ font111,/*Mangal*/ font112,/*Marlett*/ font113,/*Matura MT Script Capitals*/ font114,/*Meiryo*/ font115,/*Meiryo UI*/ font116,/*Microsoft Himalaya*/ font117,/*Microsoft JhengHei*/ font118,/*Microsoft New Tai Lue*/ font119,/*Microsoft PhagsPa*/ 
font120,/*Microsoft Sans Serif*/ font121,/*Microsoft Tai Le*/ font122,/*Microsoft Uighur*/ font123,/*Microsoft YaHei*/ font124,/*Microsoft Yi Baiti*/ font125,/*MingLiU*/ font126,/*MingLiU_HKSCS*/ font127,/*MingLiU_HKSCS-ExtB*/ font128,/*MingLiU-ExtB*/ font129,/*Miriam*/ 
font130,/*Miriam Fixed*/ font131,/*Mistral*/ font132,/*Modern*/ font133,/*Modern No.20*/ font134,/*Mongolian Baiti*/ font135,/*Monotype Corsiva*/ font136,/*MoolBoran*/ font137,/*MS Gothic*/ font138,/*MS Mincho*/ font139,/*MS Outlook*/ 
font140,/*MS PGothic*/ font141,/*MS PMincho*/ font142,/*MS Reference Sans Serif*/ font143,/*MS Reference Specialty*/ font144,/*MS Sans Serifv*/ font145,/*MS Serif*/ font146,/*MS UI Gothic*/ font147,/*MT Extra*/ font148,/*MV Boli*/ font149,/*Narkisim*/ 
font150,/*Niagara Engraved*/ font151,/*Niagara Solid*/ font152,/*NSimSun*/ font153,/*Nyala*/ font154,/*Old English Text MT*/ font155,/*Onyx*/ font156,/*Palatino Linotype*/ font157,/*Parchment*/ font158,/*Plantagenet Cherokee*/ font159,/*Playbill*/ 
font160,/*PMingLiU*/ font161,/*PMingLiU-ExtB*/ font162,/*Poor Richard*/ font163,/*Raavi*/ font164,/*Ravie*/ font165,/*Rod*/ font166,/*Roman*/ font167,/*Sakkal Majalla*/ font168,/*Script*/ font169,/*Segoe Print*/ 
font170,/*Segoe Script*/ font171,/*Segoe UI*/ font172,/*Segoe UI Light*/ font173,/*Segoe UI Semibold*/ font174,/*Segoe UI Symbol*/ font175,/*Shonar Bangla*/ font176,/*Showcard Gothic*/ font177,/*Shruti*/ font178,/*SimHei*/ font179,/*Simplified Arabic*/ 
font180,/*Simplified Arabic Fixed*/ font181,/*SimSun*/ font182,/*SimSun-ExtB*/ font183,/*Small Fonts*/ font184,/*Snap ITC*/ font185,/*Stencil*/ font186,/*Sylfaen*/ font187,/*Symbol*/ font188,/*System*/ font189,/*Tahoma*/ 
font190,/*Tempus Sans ITC*/ font191,/*Terminal*/ font192,/*Times New Roman*/ font193,/*Traditional Arabic*/ font194,/*Trebuchet MS*/ font195,/*Tunga*/ font196,/*Utsaah*/ font197,/*Vani*/ font198,/*Verdana*/ font199,/*Vijaya*/ 
font200,/*Viner Hand ITC*/ font201,/*Vivaldi*/ font202,/*Vladimir Script*/ font203,/*Vrinda*/ font204,/*Webdings*/ font205,/*Wide Latin*/ font206,/*Wingdings*/ font207,/*Wingdings 2*/ font208,/*Wingdings 3*/ 
};

string fonts_array[208]=
{
"Aharoni","Algerian","Andalus","Angsana New","AngsanaUPC","Aparajita","Arabic Typesetting","Arial","Arial Black","Arial Narrow","Arial Unicode MS","Baskenville Old Face","Batang",
"BatangChe","Bauhaus 93","Bell MT","Berlin Sans FB","Berlin Sans FB Demi","Bernard MT Condensed","Bodoni MT Poster Compressed","Book Antiqua","Bookman Old Style","Bookshelf Symbol 7",
"Britannic Bold","Broadway","Browallia New","Browa|liaUPC","Brush Script MT","Calibri","Calibri Light","Californian FB","Cambria","Cambria Math","Candara","Centaur","Century","Century Gothic",
"Chiller","Colonna MT","Comic Sans MS","Consolas","Constantia","Cooper Black","Corbel","Cordia New","CordiaUPC","Courier","Courier New","DaunPenh","David","DFKai-SB","DilleniaUPC","DokChampa",
"Dotum","DotumChe","Ebrima","Estrangelo Edessa","EucrosiaUPC","Euphemia","FangSong","Fixedsys","Footlight MT Light","Franklin Gothic Medium","FrankRuehl","FreesiaUPC","Freestyle Script","Gabriola",
"Garamond","Gautami","Georgia","Gisha","Gulim","GulimChe","Gungsuh","GungsuhChe","Haettenschweiler","Harlow Solid Italic","Harrington","High Tower Text","Impact","Informal Roman","IrisUPC",
"Iskoola Pota","JasmineUPC","Jokerman","Juice ITC","KaiTi","Kalinga","Kartika","Khmer UI","KodchiangUPC","Kokila","Kristen ITC","Kunstler Script","Lao UI","Latha","Lato","Lato Light","Lato Semibold",
"Leelawadee","Levenim MT","LilyUPC","Lucida Bright","Lucida Calligraphy","Lucida Console","Lucida Fax","Lucida Handwriting","Lucida Sans Unicode","Magneto","Malgun Gothic","Mangal","Marlett",
"Matura MT Script Capitals","Meiryo","Meiryo UI","Microsoft Himalaya","Microsoft JhengHei","Microsoft New Tai Lue","Microsoft PhagsPa","Microsoft Sans Serif","Microsoft Tai Le","Microsoft Uighur",
"Microsoft YaHei","Microsoft Yi Baiti","MingLiU","MingLiU_HKSCS","MingLiU_HKSCS-ExtB","MingLiU-ExtB","Miriam","Miriam Fixed","Mistral","Modern","Modern No.20","Mongolian Baiti","Monotype Corsiva",
"MoolBoran","MS Gothic","MS Mincho","MS Outlook","MS PGothic","MS PMincho","MS Reference Sans Serif","MS Reference Specialty","MS Sans Serifv","MS Serif","MS UI Gothic","MT Extra","MV Boli","Narkisim",
"Niagara Engraved","Niagara Solid","NSimSun","Nyala","Old English Text MT","Onyx","Palatino Linotype","Parchment","Plantagenet Cherokee","Playbill","PMingLiU","PMingLiU-ExtB","Poor Richard","Raavi",
"Ravie","Rod","Roman","Sakkal Majalla","Script","Segoe Print","Segoe Script","Segoe UI","Segoe UI Light","Segoe UI Semibold","Segoe UI Symbol","Shonar Bangla","Showcard Gothic","Shruti","SimHei",
"Simplified Arabic","Simplified Arabic Fixed","SimSun","SimSun-ExtB","Small Fonts","Snap ITC","Stencil","Sylfaen","Symbol","System","Tahoma","Tempus Sans ITC","Terminal","Times New Roman",
"Traditional Arabic","Trebuchet MS","Tunga","Utsaah","Vani","Verdana","Vijaya","Viner Hand ITC","Vivaldi","Vladimir Script","Vrinda","Webdings","Wide Latin","Wingdings","Wingdings 2","Wingdings 3"
};

enum p
{
   p0,   // Pips
   p1,   // Points
};
enum x
{
   x0,   // None   
   x1,   // Hide M1
   x2,   // Hide M1-M5
   x3,   // Hide M1-M15
   x4,   // Hide M1-M30
   x5,   // Hide M1-H1
   x6,   // Hide M1-H4
   x7,   // Hide MN-M30   
   x8,   // Hide MN-H1
   x9,   // Hide MN-H4
   x10,  // Hide MN-D1
   x11,  // Hide MN-W1
   x12,  // Hide MN 
};
enum v
{
   v0,   // None
   v1,   // Hide Ma   
   v2,   // Hide Atr   
   v3,   // Hide Tf
   v4    // Hide Ma&Atr
};

//----------------------------------------------------------

extern int     ATRPeriod                        =  13;
extern double  ATRMultiplier                    =  1;
extern int     MaOfATRPeriod                    =  8;
extern ENUM_MA_METHOD MaOfATRMethod             =  MODE_EMA;
extern int     MaOfPricePeriod                  =  21;
extern ENUM_MA_METHOD MaOfPriceMethod           =  MODE_EMA;
extern ENUM_APPLIED_PRICE MaOfPriceAppliedPrice =  PRICE_MEDIAN;  
extern p       DisplayValuesAs;
extern string  Identifier                       =  "Dashboard1";     
extern ENUM_BASE_CORNER  DisplayCorner           =  CORNER_RIGHT_UPPER;
extern int     DisplayWindow                    =  0;           
extern bool    AutoXCentered                    =  true;
extern int     XDISTANCE                        =  0;
extern int     YDISTANCE                        =  5; 
extern int     ButtonWidth                      =  80;          
extern int     ButtonHigh                       =  20;          
extern double  ButtonsYStep                     =  3;
extern double  ButtonsXStep                     =  3;
extern x       ColumnsToHide;
extern v       RowsToHide;                      
extern fonts   FontName                         =  font189;
extern int     FontSize                         =  9;           
extern color   Border_Color                     =  clrDimGray;        
extern color   AtrBGColor                       =  clrBlack; 
extern color   AtrAboveMaOfATRColor             =  clrTeal;
extern color   AtrBelowMaOfATRColor             =  clrOrange; 
extern color   PriceDistanceBGColor             =  clrBlack; 
extern color   PositivePriceDistanceColor       =  clrMediumSlateBlue;
extern color   NegativePriceDistanceColor       =  clrTomato;    
extern color   TFsBGColor                       =  clrBlack; 
extern color   TFsFGColorNormal                 =  clrRoyalBlue; 
extern color   TFsFGColorSelected               =  clrRed;    
extern color   ScFixTextColorSelected           =  clrHotPink;
extern bool    TransparentButtons               =  false;
extern int     BarsToLoad                       =  5000;

//-------------------------------------------------------------------
double   Atrp0M1,Atrp0M5,Atrp0M15,Atrp0M30,Atrp0H1,Atrp0H4,Atrp0D1,Atrp0W1,Atrp0MN,
         Atrp1M1,Atrp1M5,Atrp1M15,Atrp1M30,Atrp1H1,Atrp1H4,Atrp1D1,Atrp1W1,Atrp1MN,
         Pdisp0M1,Pdisp0M5,Pdisp0M15,Pdisp0M30,Pdisp0H1,Pdisp0H4,Pdisp0D1,Pdisp0W1,Pdisp0MN,
         Pdisp1M1,Pdisp1M5,Pdisp1M15,Pdisp1M30,Pdisp1H1,Pdisp1H4,Pdisp1D1,Pdisp1W1,Pdisp1MN,
         AtrM1,AtrM5,AtrM15,AtrM30,AtrH1,AtrH4,AtrD1,AtrW1,AtrMN,PDisM1,PDisM5,PDisM15,PDisM30,
         PDisH1,PDisH4,PDisD1,PDisW1,PDisMN,pl1,pl2,pl3,pl4,pl5,pl6,pl7,pl8,pl9,Atr1[],Pdis1[], 
         buffer_atrxM1[],buffer_atrxM5[],buffer_atrxM15[],buffer_atrxM30[],buffer_atrxH1[],
         buffer_atrxH4[],buffer_atrxD1[],buffer_atrxW1[],buffer_atrxMN[],buffer_maof_atrxM1[],
         buffer_maof_atrxM5[],buffer_maof_atrxM15[],buffer_maof_atrxM30[],buffer_maof_atrxH1[],
         buffer_maof_atrxH4[],buffer_maof_atrxD1[],buffer_maof_atrxW1[],buffer_maof_atrxMN[];
int      ButtonsInrow=10;
string   obj_atr_display,Title0[]={"TF/CS"},Title1[]={"Atr(13)"},Title2[]={"Ma(13)"},z,z1,z2;
bool     pos,c0,c1,c2,c3,c4,c5,c6,c7,c8; 


//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
  int OnInit()
  {
   IndicatorBuffers(18);                  
   SetIndexBuffer(0, buffer_atrxM1);         SetIndexEmptyValue(0, EMPTY_VALUE);       SetIndexStyle(0, DRAW_NONE);
   SetIndexBuffer(1, buffer_atrxM5);         SetIndexEmptyValue(1, EMPTY_VALUE);       SetIndexStyle(1, DRAW_NONE);
   SetIndexBuffer(2, buffer_atrxM15);        SetIndexEmptyValue(2, EMPTY_VALUE);       SetIndexStyle(2, DRAW_NONE);
   SetIndexBuffer(3, buffer_atrxM30);        SetIndexEmptyValue(3, EMPTY_VALUE);       SetIndexStyle(3, DRAW_NONE);
   SetIndexBuffer(4, buffer_atrxH1);         SetIndexEmptyValue(4, EMPTY_VALUE);       SetIndexStyle(4, DRAW_NONE);
   SetIndexBuffer(5, buffer_atrxH4);         SetIndexEmptyValue(5, EMPTY_VALUE);       SetIndexStyle(5, DRAW_NONE);
   SetIndexBuffer(6, buffer_atrxD1);         SetIndexEmptyValue(6, EMPTY_VALUE);       SetIndexStyle(6, DRAW_NONE);
   SetIndexBuffer(7, buffer_atrxW1);         SetIndexEmptyValue(7, EMPTY_VALUE);       SetIndexStyle(7, DRAW_NONE);
   SetIndexBuffer(8, buffer_atrxMN);         SetIndexEmptyValue(8, EMPTY_VALUE);       SetIndexStyle(8, DRAW_NONE);
   SetIndexBuffer(9, buffer_maof_atrxM1);    SetIndexEmptyValue(9, EMPTY_VALUE);       SetIndexStyle(9, DRAW_NONE);
   SetIndexBuffer(10,buffer_maof_atrxM5);    SetIndexEmptyValue(10,EMPTY_VALUE);       SetIndexStyle(10,DRAW_NONE);
   SetIndexBuffer(11,buffer_maof_atrxM15);   SetIndexEmptyValue(11,EMPTY_VALUE);       SetIndexStyle(11,DRAW_NONE);
   SetIndexBuffer(12,buffer_maof_atrxM30);   SetIndexEmptyValue(12,EMPTY_VALUE);       SetIndexStyle(12,DRAW_NONE);
   SetIndexBuffer(13,buffer_maof_atrxH1);    SetIndexEmptyValue(13,EMPTY_VALUE);       SetIndexStyle(13,DRAW_NONE);
   SetIndexBuffer(14,buffer_maof_atrxH4);    SetIndexEmptyValue(14,EMPTY_VALUE);       SetIndexStyle(14,DRAW_NONE);
   SetIndexBuffer(15,buffer_maof_atrxD1);    SetIndexEmptyValue(15,EMPTY_VALUE);       SetIndexStyle(15,DRAW_NONE);
   SetIndexBuffer(16,buffer_maof_atrxW1);    SetIndexEmptyValue(16,EMPTY_VALUE);       SetIndexStyle(16,DRAW_NONE);
   SetIndexBuffer(17,buffer_maof_atrxMN);    SetIndexEmptyValue(17,EMPTY_VALUE);       SetIndexStyle(17,DRAW_NONE);
   
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
   int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
  {
   int limit = rates_total - prev_calculated;
   //--- counting from 0 to rates_total
   ArraySetAsSeries(buffer_atrxM1,        true);   ArraySetAsSeries(buffer_atrxM5,      true);     ArraySetAsSeries(buffer_atrxM15,     true);
   ArraySetAsSeries(buffer_atrxM30,       true);   ArraySetAsSeries(buffer_atrxH1,      true);     ArraySetAsSeries(buffer_atrxH4,      true);
   ArraySetAsSeries(buffer_atrxD1,        true);   ArraySetAsSeries(buffer_atrxW1,      true);     ArraySetAsSeries(buffer_atrxMN,      true);
   ArraySetAsSeries(buffer_maof_atrxM1,   true);   ArraySetAsSeries(buffer_maof_atrxM5, true);     ArraySetAsSeries(buffer_maof_atrxM15,true);
   ArraySetAsSeries(buffer_maof_atrxM30,  true);   ArraySetAsSeries(buffer_maof_atrxH1, true);     ArraySetAsSeries(buffer_maof_atrxH4, true);
   ArraySetAsSeries(buffer_maof_atrxD1,   true);   ArraySetAsSeries(buffer_maof_atrxW1, true);     ArraySetAsSeries(buffer_maof_atrxMN, true);
     
   //--- initial zero
   if(prev_calculated < 1)
   {
   ArrayInitialize(buffer_atrxM1,      EMPTY_VALUE);  ArrayInitialize(buffer_atrxM5,     EMPTY_VALUE);   ArrayInitialize(buffer_atrxM15,     EMPTY_VALUE);
   ArrayInitialize(buffer_atrxM30,     EMPTY_VALUE);  ArrayInitialize(buffer_atrxH1,     EMPTY_VALUE);   ArrayInitialize(buffer_atrxH4,      EMPTY_VALUE);
   ArrayInitialize(buffer_atrxD1,      EMPTY_VALUE);  ArrayInitialize(buffer_atrxW1,     EMPTY_VALUE);   ArrayInitialize(buffer_atrxMN,      EMPTY_VALUE);
   ArrayInitialize(buffer_maof_atrxM1, EMPTY_VALUE);  ArrayInitialize(buffer_maof_atrxM5,EMPTY_VALUE);   ArrayInitialize(buffer_maof_atrxM15,EMPTY_VALUE);
   ArrayInitialize(buffer_maof_atrxM30,EMPTY_VALUE);  ArrayInitialize(buffer_maof_atrxH1,EMPTY_VALUE);   ArrayInitialize(buffer_maof_atrxH4, EMPTY_VALUE);
   ArrayInitialize(buffer_maof_atrxD1, EMPTY_VALUE);  ArrayInitialize(buffer_maof_atrxW1,EMPTY_VALUE);   ArrayInitialize(buffer_maof_atrxMN, EMPTY_VALUE);
   }
   else
   limit++;
     
   // atr loop
   for(int f = BarsToLoad; f>= 0; f--)
   {
   buffer_atrxM1[f]  = iATR(Symbol(),PERIOD_M1,ATRPeriod,f)*ATRMultiplier;
   buffer_atrxM5[f]  = iATR(Symbol(),PERIOD_M5,ATRPeriod,f)*ATRMultiplier;
   buffer_atrxM15[f] = iATR(Symbol(),PERIOD_M15,ATRPeriod,f)*ATRMultiplier;
   buffer_atrxM30[f] = iATR(Symbol(),PERIOD_M30,ATRPeriod,f)*ATRMultiplier;
   buffer_atrxH1[f]  = iATR(Symbol(),PERIOD_H1,ATRPeriod,f)*ATRMultiplier;
   buffer_atrxH4[f]  = iATR(Symbol(),PERIOD_H4,ATRPeriod,f)*ATRMultiplier;
   buffer_atrxD1[f]  = iATR(Symbol(),PERIOD_D1,ATRPeriod,f)*ATRMultiplier;
   buffer_atrxW1[f]  = iATR(Symbol(),PERIOD_W1,ATRPeriod,f)*ATRMultiplier;
   buffer_atrxMN[f]  = iATR(Symbol(),PERIOD_MN1,ATRPeriod,f)*ATRMultiplier;
   }
   
   // ma of atr loop 
   for(int b = BarsToLoad; b>= 0; b--)
   {
   buffer_maof_atrxM1[b]   = iMAOnArray(buffer_atrxM1,0,MaOfATRPeriod,0,MaOfATRMethod,b);
   buffer_maof_atrxM5[b]   = iMAOnArray(buffer_atrxM5,0,MaOfATRPeriod,0,MaOfATRMethod,b);
   buffer_maof_atrxM15[b]  = iMAOnArray(buffer_atrxM15,0,MaOfATRPeriod,0,MaOfATRMethod,b);
   buffer_maof_atrxM30[b]  = iMAOnArray(buffer_atrxM30,0,MaOfATRPeriod,0,MaOfATRMethod,b);
   buffer_maof_atrxH1[b]   = iMAOnArray(buffer_atrxH1,0,MaOfATRPeriod,0,MaOfATRMethod,b);
   buffer_maof_atrxH4[b]   = iMAOnArray(buffer_atrxH4,0,MaOfATRPeriod,0,MaOfATRMethod,b);
   buffer_maof_atrxD1[b]   = iMAOnArray(buffer_atrxD1,0,MaOfATRPeriod,0,MaOfATRMethod,b);
   buffer_maof_atrxW1[b]   = iMAOnArray(buffer_atrxW1,0,MaOfATRPeriod,0,MaOfATRMethod,b);
   buffer_maof_atrxMN[b]   = iMAOnArray(buffer_atrxMN,0,MaOfATRPeriod,0,MaOfATRMethod,b);
   }
    
   if(buffer_atrxM1[0]>=buffer_maof_atrxM1[0])   c0=true; else c0=false;   if(buffer_atrxM5[0]>=buffer_maof_atrxM5[0])   c1=true;   else c1=false;
   if(buffer_atrxM15[0]>=buffer_maof_atrxM15[0]) c2=true; else c2=false;   if(buffer_atrxM30[0]>=buffer_maof_atrxM30[0]) c3=true;   else c3=false;
   if(buffer_atrxH1[0]>=buffer_maof_atrxH1[0])   c4=true; else c4=false;   if(buffer_atrxH4[0]>=buffer_maof_atrxH4[0])   c5=true;   else c5=false;
   if(buffer_atrxD1[0]>=buffer_maof_atrxD1[0])   c6=true; else c6=false;   if(buffer_atrxW1[0]>=buffer_maof_atrxW1[0])   c7=true;   else c7=false;
   if(buffer_atrxMN[0]>=buffer_maof_atrxMN[0])   c8=true; else c8=false;
   
      
   int D = (int) MarketInfo(Symbol(),MODE_DIGITS), point = 10;
      
   Atrp1M1    = MathAbs((NormalizeDouble(((buffer_atrxM1[0])/MarketInfo(Symbol(),MODE_POINT)),D)));
   Atrp1M5    = MathAbs((NormalizeDouble(((buffer_atrxM5[0])/MarketInfo(Symbol(),MODE_POINT)),D)));
   Atrp1M15   = MathAbs((NormalizeDouble(((buffer_atrxM15[0])/MarketInfo(Symbol(),MODE_POINT)),D)));
   Atrp1M30   = MathAbs((NormalizeDouble(((buffer_atrxM30[0])/MarketInfo(Symbol(),MODE_POINT)),D)));
   Atrp1H1    = MathAbs((NormalizeDouble(((buffer_atrxH1[0])/MarketInfo(Symbol(),MODE_POINT)),D)));
   Atrp1H4    = MathAbs((NormalizeDouble(((buffer_atrxH4[0])/MarketInfo(Symbol(),MODE_POINT)),D)));
   Atrp1D1    = MathAbs((NormalizeDouble(((buffer_atrxD1[0])/MarketInfo(Symbol(),MODE_POINT)),D)));
   Atrp1W1    = MathAbs((NormalizeDouble(((buffer_atrxW1[0])/MarketInfo(Symbol(),MODE_POINT)),D)));
   Atrp1MN    = MathAbs((NormalizeDouble(((buffer_atrxMN[0])/MarketInfo(Symbol(),MODE_POINT)),D)));
      
   Atrp0M1=Atrp1M1/point;Atrp0M5=Atrp1M5/point;Atrp0M15=Atrp1M15/point;Atrp0M30=Atrp1M30/point;
   Atrp0H1=Atrp1H1/point;Atrp0H4=Atrp1H4/point;Atrp0D1=Atrp1D1/point;Atrp0W1=Atrp1W1/point;Atrp0MN=Atrp1MN/point;
   
   if(DisplayValuesAs==p0)
   {AtrM1=Atrp0M1;AtrM5=Atrp0M5;AtrM15=Atrp0M15;AtrM30=Atrp0M30;AtrH1=Atrp0H1;AtrH4=Atrp0H4;AtrD1=Atrp0D1;AtrW1=Atrp0W1;AtrMN=Atrp0MN;}
   else
   {AtrM1=Atrp1M1;AtrM5=Atrp1M5;AtrM15=Atrp1M15;AtrM30=Atrp1M30;AtrH1=Atrp1H1;AtrH4=Atrp1H4;AtrD1=Atrp1D1;AtrW1=Atrp1W1;AtrMN=Atrp1MN;}
              
   // calculate price distance to ma
     
   double mapM1     = iMA(Symbol(),PERIOD_M1,MaOfPricePeriod,0,MaOfPriceMethod,MaOfPriceAppliedPrice,0);
   double mapM5     = iMA(Symbol(),PERIOD_M5,MaOfPricePeriod,0,MaOfPriceMethod,MaOfPriceAppliedPrice,0);
   double mapM15    = iMA(Symbol(),PERIOD_M15,MaOfPricePeriod,0,MaOfPriceMethod,MaOfPriceAppliedPrice,0);
   double mapM30    = iMA(Symbol(),PERIOD_M30,MaOfPricePeriod,0,MaOfPriceMethod,MaOfPriceAppliedPrice,0);
   double mapH1     = iMA(Symbol(),PERIOD_H1,MaOfPricePeriod,0,MaOfPriceMethod,MaOfPriceAppliedPrice,0);
   double mapH4     = iMA(Symbol(),PERIOD_H4,MaOfPricePeriod,0,MaOfPriceMethod,MaOfPriceAppliedPrice,0);
   double mapD1     = iMA(Symbol(),PERIOD_D1,MaOfPricePeriod,0,MaOfPriceMethod,MaOfPriceAppliedPrice,0);
   double mapW1     = iMA(Symbol(),PERIOD_W1,MaOfPricePeriod,0,MaOfPriceMethod,MaOfPriceAppliedPrice,0);
   double mapMN     = iMA(Symbol(),PERIOD_MN1,MaOfPricePeriod,0,MaOfPriceMethod,MaOfPriceAppliedPrice,0);
     
   if(Ask>=mapM1)     {double pdisxM1  = Ask - mapM1;  pl1=1;} else {pdisxM1   = Bid - mapM1;  pl1=-1;}
   if(Ask>=mapM5)     {double pdisxM5  = Ask - mapM5;  pl2=1;} else {pdisxM5   = Bid - mapM5;  pl2=-1;}
   if(Ask>=mapM15)    {double pdisxM15 = Ask - mapM15; pl3=1;} else {pdisxM15  = Bid - mapM15; pl3=-1;}   
   if(Ask>=mapM30)    {double pdisxM30 = Ask - mapM30; pl4=1;} else {pdisxM30  = Bid - mapM30; pl4=-1;} 
   if(Ask>=mapH1)     {double pdisxH1  = Ask - mapH1;  pl5=1;} else {pdisxH1   = Bid - mapH1;  pl5=-1;}  
   if(Ask>=mapH4)     {double pdisxH4  = Ask - mapH4;  pl6=1;} else {pdisxH4   = Bid - mapH4;  pl6=-1;} 
   if(Ask>=mapD1)     {double pdisxD1  = Ask - mapD1;  pl7=1;} else {pdisxD1   = Bid - mapD1;  pl7=-1;}   
   if(Ask>=mapW1)     {double pdisxW1  = Ask - mapW1;  pl8=1;} else {pdisxW1   = Bid - mapW1;  pl8=-1;}       
   if(Ask>=mapMN)     {double pdisxMN  = Ask - mapMN;  pl9=1;} else {pdisxMN   = Bid - mapMN;  pl9=-1;}       
     
   Pdisp1M1    = MathAbs((NormalizeDouble(((pdisxM1)/MarketInfo(Symbol(),MODE_POINT)),D)));
   Pdisp1M5    = MathAbs((NormalizeDouble(((pdisxM5)/MarketInfo(Symbol(),MODE_POINT)),D)));
   Pdisp1M15   = MathAbs((NormalizeDouble(((pdisxM15)/MarketInfo(Symbol(),MODE_POINT)),D)));
   Pdisp1M30   = MathAbs((NormalizeDouble(((pdisxM30)/MarketInfo(Symbol(),MODE_POINT)),D)));
   Pdisp1H1    = MathAbs((NormalizeDouble(((pdisxH1)/MarketInfo(Symbol(),MODE_POINT)),D)));
   Pdisp1H4    = MathAbs((NormalizeDouble(((pdisxH4)/MarketInfo(Symbol(),MODE_POINT)),D)));
   Pdisp1D1    = MathAbs((NormalizeDouble(((pdisxD1)/MarketInfo(Symbol(),MODE_POINT)),D)));
   Pdisp1W1    = MathAbs((NormalizeDouble(((pdisxW1)/MarketInfo(Symbol(),MODE_POINT)),D)));
   Pdisp1MN    = MathAbs((NormalizeDouble(((pdisxMN)/MarketInfo(Symbol(),MODE_POINT)),D)));
   
   Pdisp0M1 =  Pdisp1M1/point;    Pdisp0M5 = Pdisp1M5/point;    Pdisp0M15 = Pdisp1M15/point; 
   Pdisp0M30=  Pdisp1M30/point;   Pdisp0H1 = Pdisp1H1/point;    Pdisp0H4  = Pdisp1H4/point;
   Pdisp0D1 =  Pdisp1D1/point;    Pdisp0W1 = Pdisp1W1/point;    Pdisp0MN  = Pdisp1MN/point;
      
   if(DisplayValuesAs==p0)
   {PDisM1=Pdisp0M1*pl1;PDisM5=Pdisp0M5*pl2;PDisM15=Pdisp0M15*pl3;PDisM30=Pdisp0M30*pl4;PDisH1=Pdisp0H1*pl5;
    PDisH4=Pdisp0H4*pl6;PDisD1=Pdisp0D1*pl7;PDisW1=Pdisp0W1*pl8;PDisMN=Pdisp0MN*pl9;}
   
   if(DisplayValuesAs==p1)
   {PDisM1=Pdisp1M1*pl1;PDisM5=Pdisp1M5*pl2;PDisM15=Pdisp1M15*pl3;PDisM30=Pdisp1M30*pl4;PDisH1=Pdisp1H1*pl5;
    PDisH4=Pdisp1H4*pl6;PDisD1=Pdisp1D1*pl7;PDisW1=Pdisp1W1*pl8;PDisMN=Pdisp1MN*pl9;}
    
//------------------------------------------------------------------------------------------   
   int i,r=0,h=0;  
   if(ColumnsToHide==x1)r=1;if(ColumnsToHide==x2)r=2;if(ColumnsToHide==x3)r=3;if(ColumnsToHide==x4)r=4;if(ColumnsToHide==x5)r=5;if(ColumnsToHide==x6)r=6;
   if(ColumnsToHide==x7)h=6;if(ColumnsToHide==x8)h=5;if(ColumnsToHide==x9)h=4;if(ColumnsToHide==x10)h=3;if(ColumnsToHide==x11)h=2;if(ColumnsToHide==x12)h=1;
   double height=ChartGetInteger(0,CHART_HEIGHT_IN_PIXELS,0);
   double width=ChartGetInteger(0,CHART_WIDTH_IN_PIXELS,0);   
   
   if(DisplayCorner==CORNER_LEFT_UPPER||DisplayCorner==CORNER_LEFT_LOWER)
   {if(AutoXCentered) int XD = (width/2)-((10-r-h)*ButtonWidth+(10-r-h-1)*ButtonsXStep)/2; else if (AutoXCentered!=true) XD=XDISTANCE;}
   
   if(DisplayCorner==CORNER_RIGHT_UPPER||DisplayCorner==CORNER_RIGHT_LOWER)
   {if(AutoXCentered)     XD = (width/2)-((10-r-h)*ButtonWidth+(10-r-h-1)*ButtonsXStep)/2+ButtonWidth; else if (AutoXCentered!=true) XD=XDISTANCE;}
     
   if(RowsToHide!=v3) 
   {
   int x0=0,y0=0;int ButtonsInRow=10;
   for( i=0+r; i<ArraySize(TF_s)-h; i++)
   
   {if(i>0 && MathMod(i,ButtonsInRow)==0) {x0=0; y0+=ButtonHigh;} 
   createButton(Identifier+":Time Frames:"+string(i),TF_s[i],XD+x0,YDISTANCE+y0); x0+=ButtonWidth+ButtonsXStep;}
   
   for(i=0; i<ArraySize(Title0); i++)
   {if(i>0 && MathMod(i,ButtonsInRow)==0) {x0=0; y0+=ButtonHigh;} 
   createButton(Identifier+":TF:"+string(i),"ScFix",XD+x0,YDISTANCE+y0); x0+=ButtonWidth+ButtonsXStep;}
   }   
   
   ArrayResize(Atr1,9);
   ArrayFill(Atr1,0,1,DoubleToStr(AtrM1,1));
   ArrayFill(Atr1,1,1,DoubleToStr(AtrM5,1));
   ArrayFill(Atr1,2,1,DoubleToStr(AtrM15,1));
   ArrayFill(Atr1,3,1,DoubleToStr(AtrM30,1));
   ArrayFill(Atr1,4,1,DoubleToStr(AtrH1,1));
   ArrayFill(Atr1,5,1,DoubleToStr(AtrH4,1));
   ArrayFill(Atr1,6,1,DoubleToStr(AtrD1,1));
   ArrayFill(Atr1,7,1,DoubleToStr(AtrW1,1));
   ArrayFill(Atr1,8,1,DoubleToStr(AtrMN,1));

   if(RowsToHide!=v2&&RowsToHide!=v4) 
   {
   x0=0; y0+=ButtonHigh+ButtonsYStep;
   for( i=0+r; i<ArraySize(Atr1)-h; i++)
   {if(i>0 && MathMod(i,ButtonsInRow)==0) {x0=0; y0+=ButtonHigh;} 
   createButton1(Identifier+":Atr Average Values:"+int(i),Atr1[i],XD+x0,YDISTANCE+y0); x0+=ButtonWidth+ButtonsXStep;}
   
         
   for( i=0; i<ArraySize(Title1); i++)
   {if(i>0 && MathMod(i,ButtonsInRow)==0) {x0=0; y0+=ButtonHigh;} 
   createButton1(Identifier+":Atr Average Title:"+int(i),"Atr("+IntegerToString(ATRPeriod,0)+")",XD+x0,YDISTANCE+y0); x0+=ButtonWidth+ButtonsXStep;}
   }

   ArrayResize(Pdis1,9);
   ArrayFill(Pdis1,0,1,DoubleToStr(PDisM1,1));
   ArrayFill(Pdis1,1,1,DoubleToStr(PDisM5,1));
   ArrayFill(Pdis1,2,1,DoubleToStr(PDisM15,1));
   ArrayFill(Pdis1,3,1,DoubleToStr(PDisM30,1));
   ArrayFill(Pdis1,4,1,DoubleToStr(PDisH1,1));
   ArrayFill(Pdis1,5,1,DoubleToStr(PDisH4,1));
   ArrayFill(Pdis1,6,1,DoubleToStr(PDisD1,1));
   ArrayFill(Pdis1,7,1,DoubleToStr(PDisW1,1));
   ArrayFill(Pdis1,8,1,DoubleToStr(PDisMN,1));
   
   if(RowsToHide!=v1&&RowsToHide!=v4) 
   {
   x0=0; y0+=ButtonHigh+ButtonsYStep;
   for( i=0+r; i<ArraySize(Pdis1)-h; i++)
   {if(i>0 && MathMod(i,ButtonsInRow)==0) {x0=0; y0+=ButtonHigh;} 
   createButton2(Identifier+":Pdistance To Ma Values:"+double(i),Pdis1[i],XD+x0,YDISTANCE+y0); x0+=ButtonWidth+ButtonsXStep;}
      
   for( i=0; i<1; i++)
   {if(i>0 && MathMod(i,ButtonsInRow)==0) {x0=0; y0+=ButtonHigh;} 
   createButton2(Identifier+":Pdistance To Ma Title:"+double(i),"Ma("+IntegerToString(MaOfPricePeriod,0)+")",XD+x0,YDISTANCE+y0); x0+=ButtonWidth+ButtonsXStep;}
   } 
  
   setButtonTextColor(); 
  
   return(rates_total);
   }
   
///------------------------------------------------------------------+
   string TF_s[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"}; 
   int    TF_i[] = {1,5,15,30,60,240,1440,10080,43200}; 
//+------------------------------------------------------------------+
   string timeFrameToString(int tf)
   {   
   for(int i=ArraySize(TF_i)-1; i>=0; i--)
      if(tf==TF_i[i]) return(TF_s[i]);
   return("");
   } 
//+------------------------------------------------------------------+
   int stringToTimeFrame(string tf)
   {
   for(int i=ArraySize(TF_s)-1; i>=0; i--)
      if(tf==TF_s[i]) return(TF_i[i]);
   return(0);
   }
//+------------------------------------------------------------------+
//| Deinit                                                           |         
//+------------------------------------------------------------------+
   int deinit()
   {
   for (int i = ObjectsTotal() - 1; i >= 0; i--)
   {
   z = ObjectName(i);
   if((StringFind(z,Identifier,0)!=-1)&&((StringFind(z,":Time Frames:",0)!=-1)||(StringFind(z,":TF:",0)!=-1)))
   ObjectDelete(z);
   z1 = ObjectName(i);
   if((StringFind(z1,Identifier,0)!=-1)&&((StringFind(z1,":Atr Average Values:")!=-1)||(StringFind(z1,":Atr Average Title:")!=-1)))
   ObjectDelete(z1);
   z2 = ObjectName(i);
   if((StringFind(z2,Identifier,0)!=-1)&&((StringFind(z2,":Pdistance To Ma Values:",0)!=-1)||(StringFind(z2,":Pdistance To Ma Title:",0)!=-1)))ObjectDelete(z2);   
   }
   return(0);
   }
//+------------------------------------------------------------------+ 

   void createButton(string name,string caption,int x0,int y0)
   {
   if(ObjectFind(name)!=0)
   ObjectCreate(name,OBJ_BUTTON,DisplayWindow,0,0,0,0,0,0);
   ObjectSet(name,OBJPROP_CORNER,0);
   ObjectSet(name,OBJPROP_XDISTANCE,x0);
   ObjectSet(name,OBJPROP_YDISTANCE,y0);
   ObjectSet(name,OBJPROP_XSIZE,ButtonWidth);
   ObjectSet(name,OBJPROP_YSIZE,ButtonHigh);
   ObjectSetText(name,caption,FontSize,fonts_array[FontName]);
   ObjectSetString(0,name,OBJPROP_FONT,fonts_array[FontName]);
   ObjectSet(name,OBJPROP_FONTSIZE,FontSize);
   ObjectSet(name,OBJPROP_BORDER_TYPE,BORDER_FLAT);
   ObjectSet(name,OBJPROP_COLOR,TFsFGColorNormal);
   ObjectSet(name,OBJPROP_BGCOLOR,TFsBGColor);
   ObjectSet(name,OBJPROP_BACK,TransparentButtons);
   ObjectSet(name,OBJPROP_BORDER_COLOR,Border_Color);
   ObjectSet(name,OBJPROP_STATE,false);
   ObjectSet(name,OBJPROP_HIDDEN,false);
   ObjectSet(name,OBJPROP_CORNER,DisplayCorner);
   z=name;
   }

   void createButton1(string name1,string caption1,int x0,int y0)
   {
   if(ObjectFind(name1)!=0)
   ObjectCreate(name1,OBJ_BUTTON,DisplayWindow,0,0,0,0,0,0);
   ObjectSet(name1,OBJPROP_CORNER,0);
   ObjectSet(name1,OBJPROP_XDISTANCE,x0);
   ObjectSet(name1,OBJPROP_YDISTANCE,y0);
   ObjectSet(name1,OBJPROP_XSIZE,ButtonWidth);
   ObjectSet(name1,OBJPROP_YSIZE,ButtonHigh);
   ObjectSetText(name1,caption1,FontSize,fonts_array[FontName]);
   ObjectSetString(0,name1,OBJPROP_FONT,fonts_array[FontName]);
   ObjectSet(name1,OBJPROP_FONTSIZE,FontSize);
   ObjectSet(name1,OBJPROP_BORDER_TYPE,BORDER_FLAT);
   ObjectSet(name1,OBJPROP_COLOR,AtrAboveMaOfATRColor);
   ObjectSet(name1,OBJPROP_BGCOLOR,AtrBGColor);
   ObjectSet(name1,OBJPROP_BACK,TransparentButtons);
   ObjectSet(name1,OBJPROP_BORDER_COLOR,Border_Color);
   ObjectSet(name1,OBJPROP_STATE,false);
   ObjectSet(name1,OBJPROP_HIDDEN,false);
   ObjectSet(name1,OBJPROP_CORNER,DisplayCorner);
   z1=name1;
   }

   void createButton2(string name2,string caption2,int x0,int y0)
   {
   if(ObjectFind(name2)!=0)
   ObjectCreate(name2,OBJ_BUTTON,DisplayWindow,0,0,0,0,0,0);
   ObjectSet(name2,OBJPROP_CORNER,0);
   ObjectSet(name2,OBJPROP_XDISTANCE,x0);
   ObjectSet(name2,OBJPROP_YDISTANCE,y0);
   ObjectSet(name2,OBJPROP_XSIZE,ButtonWidth);
   ObjectSet(name2,OBJPROP_YSIZE,ButtonHigh);
   ObjectSetText(name2,caption2,FontSize,fonts_array[FontName]);
   ObjectSetString(0,name2,OBJPROP_FONT,fonts_array[FontName]);
   ObjectSet(name2,OBJPROP_FONTSIZE,FontSize);
   ObjectSet(name2,OBJPROP_BORDER_TYPE,BORDER_FLAT);
   ObjectSet(name2,OBJPROP_COLOR,PositivePriceDistanceColor);
   ObjectSet(name2,OBJPROP_BGCOLOR,PriceDistanceBGColor);
   ObjectSet(name2,OBJPROP_BACK,TransparentButtons);
   ObjectSet(name2,OBJPROP_BORDER_COLOR,Border_Color);
   ObjectSet(name2,OBJPROP_STATE,false);
   ObjectSet(name2,OBJPROP_HIDDEN,false);
   ObjectSet(name2,OBJPROP_CORNER,DisplayCorner);
   z2=name2;
   }
   
//+------------------------------------------------------------------
   void setButtonTextColor()
   {
   string lookFor       = Identifier+":Time Frames:"; string lookForA = Identifier+":TF:";
   int    lookForLength = StringLen(lookFor); int    lookForLengthA = StringLen(lookForA);
   
   for(int i=ObjectsTotal(); i>=0; i--)
     {
         string objectName=ObjectName(i);
      
         if(StringSubstr(objectName,0,lookForLength)==lookFor)
         {
         int time = stringToTimeFrame(ObjectGetString(0,objectName,OBJPROP_TEXT));
         if(time != _Period)
         ObjectSet(objectName,OBJPROP_COLOR,TFsFGColorNormal);
         else  ObjectSet(objectName,OBJPROP_COLOR,TFsFGColorSelected);
         }
         
         if(StringFind(objectName,Identifier+":TF:",0)!=-1)
         {
         if (ChartGetInteger(0,CHART_SCALEFIX,true))
         ObjectSet(objectName,OBJPROP_COLOR,ScFixTextColorSelected);
         else  ObjectSet(objectName,OBJPROP_COLOR,TFsFGColorNormal);
         }
         
         if(StringFind(objectName,Identifier+":Pdistance To Ma Values:0",0)!=-1)
         {
         if (PDisM1<0)
         ObjectSet(objectName,OBJPROP_COLOR,NegativePriceDistanceColor);
         else  ObjectSet(objectName,OBJPROP_COLOR,PositivePriceDistanceColor);
         }
         if(StringFind(objectName,Identifier+":Pdistance To Ma Values:1",0)!=-1)
         {
         if (PDisM5<0)
         ObjectSet(objectName,OBJPROP_COLOR,NegativePriceDistanceColor);
         else  ObjectSet(objectName,OBJPROP_COLOR,PositivePriceDistanceColor);
         }              
         if(StringFind(objectName,Identifier+":Pdistance To Ma Values:2",0)!=-1)
         {
         if (PDisM15<0)
         ObjectSet(objectName,OBJPROP_COLOR,NegativePriceDistanceColor);
         else  ObjectSet(objectName,OBJPROP_COLOR,PositivePriceDistanceColor);
         }
         if(StringFind(objectName,Identifier+":Pdistance To Ma Values:3",0)!=-1)
         {
         if (PDisM30<0)
         ObjectSet(objectName,OBJPROP_COLOR,NegativePriceDistanceColor);
         else  ObjectSet(objectName,OBJPROP_COLOR,PositivePriceDistanceColor);
         }              
         if(StringFind(objectName,Identifier+":Pdistance To Ma Values:4",0)!=-1)
         {
         if (PDisH1<0)
         ObjectSet(objectName,OBJPROP_COLOR,NegativePriceDistanceColor);
         else  ObjectSet(objectName,OBJPROP_COLOR,PositivePriceDistanceColor);
         }
         if(StringFind(objectName,Identifier+":Pdistance To Ma Values:5",0)!=-1)
         {
         if (PDisH4<0)
         ObjectSet(objectName,OBJPROP_COLOR,NegativePriceDistanceColor);
         else  ObjectSet(objectName,OBJPROP_COLOR,PositivePriceDistanceColor);
         }
         if(StringFind(objectName,Identifier+":Pdistance To Ma Values:6",0)!=-1)
         {
         if (PDisD1<0)
         ObjectSet(objectName,OBJPROP_COLOR,NegativePriceDistanceColor);
         else  ObjectSet(objectName,OBJPROP_COLOR,PositivePriceDistanceColor);
         }
         if(StringFind(objectName,Identifier+":Pdistance To Ma Values:7",0)!=-1)
         {
         if (PDisW1<0)
         ObjectSet(objectName,OBJPROP_COLOR,NegativePriceDistanceColor);
         else  ObjectSet(objectName,OBJPROP_COLOR,PositivePriceDistanceColor);
         }
         if(StringFind(objectName,Identifier+":Pdistance To Ma Values:8",0)!=-1)
         {
         if (PDisMN<0)
         ObjectSet(objectName,OBJPROP_COLOR,NegativePriceDistanceColor);
         else  ObjectSet(objectName,OBJPROP_COLOR,PositivePriceDistanceColor);
         }
         
         if(StringFind(objectName,Identifier+":Atr Average Values:0",0)!=-1)
         {
         if (c0)
         ObjectSet(objectName,OBJPROP_COLOR,AtrAboveMaOfATRColor);
         else  ObjectSet(objectName,OBJPROP_COLOR,AtrBelowMaOfATRColor);
         }
         if(StringFind(objectName,Identifier+":Atr Average Values:1",0)!=-1)
         {
         if (c1)
         ObjectSet(objectName,OBJPROP_COLOR,AtrAboveMaOfATRColor);
         else  ObjectSet(objectName,OBJPROP_COLOR,AtrBelowMaOfATRColor);
         }
         if(StringFind(objectName,Identifier+":Atr Average Values:2",0)!=-1)
         {
         if (c2)
         ObjectSet(objectName,OBJPROP_COLOR,AtrAboveMaOfATRColor);
         else  ObjectSet(objectName,OBJPROP_COLOR,AtrBelowMaOfATRColor);
         }         
         if(StringFind(objectName,Identifier+":Atr Average Values:3",0)!=-1)
         {
         if (c3)
         ObjectSet(objectName,OBJPROP_COLOR,AtrAboveMaOfATRColor);
         else  ObjectSet(objectName,OBJPROP_COLOR,AtrBelowMaOfATRColor);
         }
         if(StringFind(objectName,Identifier+":Atr Average Values:4",0)!=-1)
         {
         if (c4)
         ObjectSet(objectName,OBJPROP_COLOR,AtrAboveMaOfATRColor);
         else  ObjectSet(objectName,OBJPROP_COLOR,AtrBelowMaOfATRColor);
         }
         if(StringFind(objectName,Identifier+":Atr Average Values:5",0)!=-1)
         {
         if (c5)
         ObjectSet(objectName,OBJPROP_COLOR,AtrAboveMaOfATRColor);
         else  ObjectSet(objectName,OBJPROP_COLOR,AtrBelowMaOfATRColor);
         }
         if(StringFind(objectName,Identifier+":Atr Average Values:6",0)!=-1)
         {
         if (c6)
         ObjectSet(objectName,OBJPROP_COLOR,AtrAboveMaOfATRColor);
         else  ObjectSet(objectName,OBJPROP_COLOR,AtrBelowMaOfATRColor);
         }
         if(StringFind(objectName,Identifier+":Atr Average Values:7",0)!=-1)
         {
         if (c7)
         ObjectSet(objectName,OBJPROP_COLOR,AtrAboveMaOfATRColor);
         else  ObjectSet(objectName,OBJPROP_COLOR,AtrBelowMaOfATRColor);
         }
         if(StringFind(objectName,Identifier+":Atr Average Values:8",0)!=-1)
         {
         if (c8)
         ObjectSet(objectName,OBJPROP_COLOR,AtrAboveMaOfATRColor);
         else  ObjectSet(objectName,OBJPROP_COLOR,AtrBelowMaOfATRColor);
         }  
     }
   }

//--------------------------------------------------------------------
   void OnChartEvent(const int id,const long &lparam,const double &dparam,const string &sparam)
  {
  if(id==CHARTEVENT_OBJECT_CLICK && ObjectGet(sparam,OBJPROP_TYPE)==OBJ_BUTTON)
     
  if(StringFind(sparam,Identifier+":Time Frames:",0)!=-1) 
  ChartSetSymbolPeriod(0,_Symbol,stringToTimeFrame(ObjectGetString(0,sparam,OBJPROP_TEXT)));
  
  if (ChartGetInteger(0,CHART_SCALEFIX,true)) bool scfix=false; else scfix=true;          
  if(StringFind(sparam,Identifier+":TF:",0)==0)
  ChartSetInteger(0, CHART_SCALEFIX, 0, scfix);
  }
//+-------------------------------------------------------------------- 





























